<div class="card">
    <h4 class="card-header">Register</h4>
    <div class="card-body">
        <form [formGroup]="form" (ngSubmit)="onSubmit()">
            <div class="form-group">
                <label for="username">Username</label>
                <input type="text" formControlName="username" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.username.errors }" />
                <div *ngIf="submitted && f.username.errors" class="invalid-feedback">
                    <div *ngIf="f.username.errors.required">Username is required</div>
                </div>
            </div>
            <div class="form-group">
                <label for="name">Name</label>
                <input type="text" formControlName="name" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.name.errors }" />
                <div *ngIf="submitted && f.name.errors" class="invalid-feedback">
                    <div *ngIf="f.name.errors.required">Name is required</div>
                </div>
            </div>
            <div class="form-group">
                <label for="password">Password</label>
                <input type="password" formControlName="password" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.password.errors }" />
                <div *ngIf="submitted && f.password.errors" class="invalid-feedback">
                    <div *ngIf="f.password.errors.required">Password is required</div>
                    <div *ngIf="f.password.errors.minlength">Password must be at least 6 characters</div>
                </div>
            </div>
            <div class="form-group">
                <label for="age">Age</label>
                <input type="age" formControlName="age" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.age.errors }" />
                <div *ngIf="submitted && f.age.errors" class="invalid-feedback">
                    <div *ngIf="f.age.errors.required">Age is required</div>
                    <div *ngIf="f.age.errors.pattern">Age must be a number</div>
                </div>
            </div>
            <div class="form-group">
                <label for="location">Location</label>
                <input type="location" formControlName="location" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.location.errors }" />
                <div *ngIf="submitted && f.location.errors" class="invalid-feedback">
                    <div *ngIf="f.location.errors.required">Location is required</div>
                </div>
            </div>
            <div>Gender:</div>
            <div class="radio">
                <label>
                    <input type="radio" value="MALE" formControlName="sex">
                      <span>male</span>
                  </label>
                  <label>
                    <input type="radio" value="FEMALE" formControlName="sex">
                      <span>female</span>
                  </label>
                  <label>
                    <input type="radio" value="OTHER" formControlName="sex">
                      <span>other</span>
                  </label>
                <div *ngIf="submitted && f.sex.errors" class="invalid-feedback">
                    <div *ngIf="f.sex.errors.required">Gender is required</div>
                </div>
            </div>
            <div class="form-group">
                <button [disabled]="loading" class="btn btn-primary">
                    <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
                    Register
                </button>
                <a routerLink="../login" class="btn btn-link">Cancel</a>
            </div>
        </form>
    </div>
    <div *ngIf="flagNotGood">Invalid request!</div>   
</div>
